<form (ngSubmit)="onSubmit()"
      [formGroup]="form"
      [solidifyFocusFirstElement]="true"
>
  <solidify-detail-presentation [centerTemplate]="centerTemplate"
                                [iconName]="iconNameEnum.extendRetention"
                                [rightTemplate]="rightTemplate"
  ></solidify-detail-presentation>

  <ng-template #centerTemplate>

    <mat-form-field *ngIf="getFormControl(formDefinition.name) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.nameLabel | translate }}</mat-label>
      <input [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             autofocus
             matInput
             tabindex="0"
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.taskType) as fd"
                    [appearance]="appearanceInputMaterial"
                    [floatLabel]="positionLabelInputMaterial"
                    [class.mat-form-field-invalid]="(formValidationHelper.hasRequiredField(fd) && (fd.value | isNullOrUndefinedOrWhiteString)) || fd.invalid"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.taskTypeLabel | translate}}</mat-label>
      <mat-select [formControl]="fd"
                  [required]="formValidationHelper.hasRequiredField(fd)"
                  [solidifyValidation]="errors"
      >
        <mat-option *ngFor="let type of taskTypeEnumTranslate"
                    [value]="type.key"
        >
          {{type.value | translate}}
        </mat-option>
      </mat-select>
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.cronExpression) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.cronExpression | translate }}</mat-label>
      <input [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             matInput
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <mat-form-field *ngIf="readonly"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(getFormControl(formDefinition.lastExecutionStart),
                    displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.lastExecutionStart | translate }}</mat-label>
      <input [formControl]="getFormControl(formDefinition.lastExecutionStart)"
             [required]="formValidationHelper.hasRequiredField(getFormControl(formDefinition.lastExecutionStart))"
             [solidifyValidation]="errors"
             matInput
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <mat-form-field *ngIf="readonly"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(getFormControl(formDefinition.lastExecutionEnd), displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.lastExecutionEnd | translate }}</mat-label>
      <input [formControl]="getFormControl(formDefinition.lastExecutionEnd)"
             [required]="formValidationHelper.hasRequiredField(getFormControl(formDefinition.lastExecutionEnd))"
             [solidifyValidation]="errors"
             matInput
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>
  </ng-template>

  <ng-template #rightTemplate>

    <mat-checkbox [formControlName]="formDefinition.enabled"
                  color="primary"
    >{{labelTranslateEnum.enabled | translate}}</mat-checkbox>

  </ng-template>

  <dlcm-shared-additional-information-panel-container *ngIf="model | isNotNullNorUndefined"
                                                      [resource]="model"
  >
  </dlcm-shared-additional-information-panel-container>
</form>
